/*
*	Script de creación de los triggers
*/
CREATE OR REPLACE TRIGGER t_sintetic_university_id
    BEFORE INSERT ON universidad
    FOR EACH ROW
BEGIN
    SELECT s_universidad.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_university_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_profesor_responsable_id
    BEFORE INSERT ON profesor_responsable
    FOR EACH ROW
BEGIN
    SELECT s_profesor_responsable.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_s_profesor_responsable_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_estudiante_id
    BEFORE INSERT ON estudiante
    FOR EACH ROW
BEGIN
    SELECT s_estudiante.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_s_estudiante_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_empresa_id
    BEFORE INSERT ON empresa
    FOR EACH ROW
BEGIN
    SELECT s_empresa.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_empresa_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_inspeccion_id
    BEFORE INSERT ON inspeccion
    FOR EACH ROW
BEGIN
    SELECT s_inspeccion.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_inspeccion_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_solicitante_id
    BEFORE INSERT ON solicitante
    FOR EACH ROW
BEGIN
    SELECT s_solicitante.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_solicitante_id;
/

CREATE OR REPLACE TRIGGER t_sintetic_oferta_id
    BEFORE INSERT ON oferta
    FOR EACH ROW
BEGIN
    SELECT s_oferta.NEXTVAL INTO :NEW.id FROM DUAL;
END t_sintetic_oferta_id;
/
