DECLARE
	v_resultado logs.resultado%TYPE;
	--
	v_universidad_id universidad.id%TYPE;
	v_titulacion_cod titulacion.codigo%TYPE;
	v_profesor_id profesor_responsable.id%TYPE;
	v_estudiante_id estudiante.id%TYPE;
	v_empresa_id empresa.id%TYPE;
	v_solicitante_id solicitante.id%TYPE;
    v_oferta_id oferta.id%TYPE;
	--
	TYPE a_str IS VARRAY(200) OF VARCHAR2(25);
    a_nombre a_str := a_str('Ágata', 'Alma', 'Alonso', 'Amador', 'Amelia', 'América', 'Ana', 'Anabel', 'Anastasio', 'Ani', 'Aránzazu', 'Asunción', 'Bernardino', 'Blas', 'Cándida', 'Cayetana', 'Che', 'Chema', 'Cipriano', 'Ciro', 'Cruz', 'Custodia', 'Custodio', 'Dani', 'Dionisia', 'Domitila', 'Edgardo', 'Eladio', 'Eli', 'Eliana', 'Eligia', 'Eloísa', 'Erasmo', 'Eric', 'Eugenia', 'Florentino', 'Geraldo', 'Godofredo', 'Graciana', 'Graciela', 'Guillermo', 'Haydée', 'Héctor', 'Isidoro', 'Jacobo', 'Jonatan', 'Jordana', 'Jorge', 'José', 'Judith', 'Lucas', 'Luciano', 'Luna', 'Lupe', 'Lupita', 'Marcela', 'Marcia', 'Marcial', 'María', 'Maristela', 'Martin', 'Martina', 'Miriam', 'Modesto', 'Nazario', 'Néstor', 'Nico', 'Paloma', 'Pánfilo', 'Pastor', 'Patricia', 'Perla', 'Pía', 'Plinio', 'Renata', 'Renato', 'Rosalinda', 'Ruben', 'Ruperta', 'Ruperto', 'Ruth', 'Sandalio', 'Sarita', 'Simón', 'Tito', 'Trinidad', 'Vinicio', 'Violeta', 'Yésica', 'Zacarías', 'Zaida', 'Zaira'); 
    a_apellido a_str := a_str('Abellán', 'Abril', 'Aguilera', 'Aguiló', 'Agustín', 'Alegria', 'Alemán', 'Amat', 'Amigó', 'Anglada', 'Arjona', 'Armas', 'Arnaiz', 'Arribas', 'Atienza', 'Aznar', 'Badía', 'Ballester', 'Barberá', 'Barco', 'Barrera', 'Barriga', 'Bartolomé', 'Bas', 'Bellido', 'Bermudez', 'Bernat', 'Blanca', 'Blanch', 'Bosch', 'Botella', 'Bravo', 'Cabanillas', 'Cáceres', 'Cal', 'Calatayud', 'Calvet', 'Cámara', 'Campillo', 'Canales', 'Canet', 'Cantero', 'Cárdenas', 'Carranza', 'Casado', 'Casanova', 'Casares', 'Catalá', 'Catalán', 'Céspedes', 'Chacón', 'Chamorro', 'Coloma', 'Conesa', 'Contreras', 'Corominas', 'Cortes', 'Crespo', 'Criado', 'Cuervo', 'Cuesta', 'Cuevas', 'Delgado', 'Doménech', 'Elías', 'Enríquez', 'Escrivá', 'Fabra', 'Falcón', 'Flor', 'Fonseca', 'Frutos', 'Gallo', 'Garrido', 'Garriga', 'Gaya', 'Giner', 'Gomis', 'Gonzalez', 'Gonzalo', 'Guardiola', 'Gutierrez', 'Hernández', 'Herranz', 'Huerta', 'Iborra', 'Iriarte', 'Jáuregui', 'Lamas', 'León', 'Llamas', 'López', 'Luís', 'Luque', 'Machado', 'Madrid', 'Manzano', 'Marin', 'Martin', 'Martín', 'Martinez', 'Martínez', 'Mendoza', 'Menéndez', 'Moll', 'Montes', 'Mosquera', 'Mur', 'Narváez', 'Nieto', 'Noguera', 'Nogués', 'Novoa', 'Ojeda', 'Oller', 'Olmedo', 'Osorio', 'Osuna', 'Palau', 'Palomares', 'Paredes', 'Paz', 'Pedraza', 'Pellicer', 'Peñas', 'Pera', 'Perales', 'Peralta', 'Pino', 'Pla', 'Planas', 'Pombo', 'Porras', 'Portero', 'Prado', 'Pujadas', 'Pulido', 'Querol', 'Rebollo', 'Reig', 'Revilla', 'Ribas', 'Río', 'Rivero', 'Rocamora', 'Roma', 'Ros', 'Rubio', 'Sales', 'Sánchez', 'Sancho', 'Santos', 'Seco', 'Suárez', 'Tejada', 'Tejedor', 'Tena', 'Terrón', 'Tirado', 'Toledo', 'Tomas', 'Tovar', 'Valera', 'Valero', 'Valls', 'Varela', 'Vélez', 'Vidal', 'Villar', 'Villegas', 'Yuste', 'Zaragoza', 'Zorrilla');
    v_nombre_completo solicitante.nombre%TYPE;
	a_empresa a_str := a_str('SEAT', 'Volkswagen', 'Vueling Airlines', 'Fersa', 'Only Apartments', 'Caprabo', 'Lidl', 'Grifols', 'Puig', 'Mango');
	--
	num_profs NUMBER;
	num_studs NUMBER;
	num_cursa NUMBER;
	num_solis NUMBER;
	num_offers NUMBER;
    num_cands NUMBER;
	num_inspec NUMBER;
	--
	CURSOR cursando IS
    SELECT *
    FROM cursa
    WHERE anyo_acad = anyoActual();
    --
    CURSOR ofertas (p_rows NUMBER) IS
    SELECT *
    FROM oferta
    WHERE anyo_acad = anyoActual()
    ORDER BY DBMS_RANDOM.VALUE
	FETCH FIRST p_rows ROWS ONLY;
	--
	CURSOR candidates IS
    SELECT *
    FROM candidatura c
    JOIN oferta o ON c.oferta_id = o.id
	WHERE o.anyo_acad = anyoActual();
	--
	CURSOR entrevistas IS
	SELECT e.empresa_id, e.universidad_id, e.estudiante_id, e.oferta_id
	FROM entrevista e
	 JOIN oferta o ON e.oferta_id = o.id
	WHERE e.es_apto = '1'
	 AND o.anyo_acad = anyoActual();
	--
	CURSOR inspeccionables IS
	SELECT c.empresa_id, MIN(c.fecha_inicio) inicio, MAX(c.fecha_final) final, FLOOR((MAX(c.fecha_final) - MIN(c.fecha_inicio)) / 30) meses
	FROM colaboracion c
	 JOIN oferta o ON c.oferta_id = o.id
    WHERE o.anyo_acad = anyoActual()
	GROUP BY c.empresa_id;
	--
	CURSOR colaboraciones IS
	SELECT c.empresa_id, c.universidad_id, c.estudiante_id, c.oferta_id, o.solicitante_id, c.fecha_inicio, c.fecha_final, c.informes_esperados
	FROM colaboracion c
	 JOIN oferta o ON c.oferta_id = o.id
    WHERE o.anyo_acad = anyoActual();
	--
	v_datmin_j NUMBER;
	v_datmax_j NUMBER;
	--
	v_salto NUMBER;
	v_fech_insp_j NUMBER;
	v_fecha_inf_j NUMBER;
	--
	v_fecha_inicio colaboracion.fecha_inicio%TYPE;
	v_fecha_final colaboracion.fecha_final%TYPE;
	--
	v_salida NUMBER;
BEGIN
	/*
	*	Script de pruebas de la base de datos de control de prácticas
	*/
	-- Se modifica el curso actual al curso 2020 - 2021 para tener margen para poder introducir datos para varios cursos académicos
	UPDATE re_any_univ
	SET anyo_univ = '20-21';
	
	/*
	*	Se insertan 10 universidades iniciales
	*/
	v_resultado := pq_abm.altaUniversidad('Universidad de Barcelona (UB)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Autónoma de Barcelona (UAB)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Politécnica de Catalunya (UPC)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Pompeu Fabra (UPF)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad de Lleida (UdL)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad de Girona (UdG)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Rovira i Virgili (URV)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Oberta de Catalunya (UOC)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universitat Ramon Llull (URL)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad de Vic', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
		
	/*
	*	Se insertan 14 titulaciones
	*/
	v_resultado := pq_abm.altaTitulacion('COD01', 'Ingeniería Geológica');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD02', 'Ingeniería Geomática y Topografía');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD03', 'Ingeniería Industrial');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD04', 'Ingeniería Informática');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD05', 'Ingeniería Matemática');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD06', 'Ingeniería Mecánica');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD07', 'Ingeniería Mecatrónica');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD08', 'Ingeniería Náutica y Transporte Marítimo');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD09', 'Ingeniería Naval y Oceánica');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD10', 'Ingeniería Química');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD11', 'Ingeniería Robótica');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD12', 'Ingeniería Telemática');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD13', 'Ingeniería y desarrollo del Software');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaTitulacion('COD14', 'Piloto y Dirección de Operaciones Aéreas');
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	
	/*
	*	Se dan de alta 10 empresas
	*/
	FOR i IN 1..10 LOOP
		v_resultado := pq_abm.altaEmpresa(DBMS_RANDOM.STRING('A', 10), a_empresa(i), DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 10), DBMS_RANDOM.STRING('A', 50));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre 15 y 20 personas responsables
	*/
	num_solis := FLOOR(DBMS_RANDOM.VALUE(15, 21));
	FOR i IN 1..num_solis LOOP
		SELECT id
		INTO v_empresa_id
		FROM empresa
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_nombre_completo := a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))) || ' ' || a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))) || ' ' || a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1)));
		
		v_resultado := pq_abm.altaSolicitante(v_empresa_id, v_nombre_completo, DBMS_RANDOM.STRING('A', 15));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se insertan profesores
	*/
	-- Se insertan entre 10 y 20 profesores en universidades de manera aleatoria
	num_profs := FLOOR(DBMS_RANDOM.VALUE(10, 21));
	FOR i IN 1..num_profs LOOP
		SELECT id
		INTO v_universidad_id
		FROM universidad
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaProfesor(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;

	/*
	*	Se insertan alumnos
	*/
	-- Se insertan entre 30 y 40 alumnos en las universidades que tienen profesores de manera aleatoria
	num_studs := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_studs LOOP
		SELECT DISTINCT universidad_id
		INTO v_universidad_id
		FROM profesor_responsable
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaEstudiante(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre el 80 y 90 % de estudiantes en cursos de manera aleatoria
	*/
	num_cursa := FLOOR(DBMS_RANDOM.VALUE(num_studs * 0.8, num_studs * 0.9));
	FOR i IN 1..num_cursa LOOP
		SELECT e.universidad_id, t.codigo, p.id prof_id, e.id stud_id
		INTO v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id
		FROM estudiante e
		 JOIN profesor_responsable p ON e.universidad_id = p.universidad_id
		 CROSS JOIN titulacion t
		WHERE e.id NOT IN (
			SELECT DISTINCT estudiante_id
			FROM cursa
			WHERE anyo_acad = anyoActual()
		)
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaCursa(v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id, anyoActual());
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre 30 y 40 ofertas con entre 2 y 5 plazas cada una
	*/
	num_offers := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_offers LOOP
		SELECT empresa_id, id
		INTO v_empresa_id, v_solicitante_id
		FROM solicitante
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaOferta(v_empresa_id, v_solicitante_id, DBMS_RANDOM.STRING('A', 30), NULL, FLOOR(DBMS_RANDOM.VALUE(2, 6)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	v_datmin_j := TO_NUMBER(TO_CHAR(TO_DATE('01/09/2022', 'dd/mm/rrrr'), 'J'));
	v_datmax_j := TO_NUMBER(TO_CHAR(TO_DATE('01/04/2023', 'dd/mm/rrrr'), 'J'));
	/*
	*	De los estudiantes que cursan estudios en el año académico actual se presentan candidaturas a entre 1 y 3 ofertas
	*/
    FOR cursa IN cursando LOOP
        num_cands := FLOOR(DBMS_RANDOM.VALUE(1, 4));
        FOR oferta IN ofertas(num_cands) LOOP
            v_resultado := pq_abm.altaCandidatura(cursa.universidad_id, cursa.estudiante_id, oferta.id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
        END LOOP;
    END LOOP;
	
	/*
	*	Se realizan entrevistas para todas las candidaturas presentadas
	*/
	FOR candidate IN candidates LOOP
        v_resultado := pq_abm.altaEntrevista(candidate.universidad_id, candidate.estudiante_id, candidate.oferta_id, candidate.empresa_id, candidate.solicitante_id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'),  DBMS_RANDOM.STRING('A', 30), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
    END LOOP;
	
	/*
	*	De las entrevistas con resultado apto se obtienen las colaboraciones
	*/
	FOR entrevista IN entrevistas LOOP
		v_fecha_inicio := TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmin_j + 60)), 'J');
		v_fecha_final := ADD_MONTHS(v_fecha_inicio, FLOOR(DBMS_RANDOM.VALUE(6, 13)));
		v_resultado := pq_abm.altaColaboracion(entrevista.empresa_id, entrevista.universidad_id, entrevista.estudiante_id, entrevista.oferta_id, v_fecha_inicio, v_fecha_final, FLOOR(DBMS_RANDOM.VALUE(3, 11)) * 100, FLOOR(DBMS_RANDOM.VALUE(3, 11)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se realizan inspecciones de manera aleatoria entre las empresas que tienen contratos de prácticas
	*/
	FOR inspeccionable IN inspeccionables LOOP
		num_inspec := FLOOR(DBMS_RANDOM.VALUE(inspeccionable.meses / 2, inspeccionable.meses));
		v_datmin_j := TO_NUMBER(TO_CHAR(inspeccionable.inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(inspeccionable.final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / num_inspec);
		v_fech_insp_j := v_datmin_j + v_salto;
		
		FOR i IN 1..num_inspec LOOP
			v_resultado := pq_abm.altaInspeccion(inspeccionable.empresa_id, TO_DATE(v_fech_insp_j, 'J'), DBMS_RANDOM.STRING('A', 30));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fech_insp_j := v_fech_insp_j + v_salto;
		END LOOP;
	END LOOP;
	
	/*
	*	Se insertan los informes de cada colaboración
	*/
	FOR colaboracion IN colaboraciones LOOP
		v_datmin_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / colaboracion.informes_esperados);
		v_fecha_inf_j := v_datmin_j + v_salto;
		
		FOR i IN 1..colaboracion.informes_esperados - 1 LOOP
			v_resultado := pq_abm.altaInforme(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fecha_inf_j := v_fecha_inf_j + v_salto;
		END LOOP;
		
		v_fecha_inf_j := v_datmax_j + 5;
		v_resultado := pq_abm.altaInformeFinal(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200), DBMS_RANDOM.STRING('A', 200), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	-- Se modifica el curso actual al siguiente curso actualizando las tablas del repositorio estadístico
	pq_dw.resetCurso('21-22');
	
	-- Se insertan entre 5 y 10 profesores nuevos manera aleatoria
	num_profs := FLOOR(DBMS_RANDOM.VALUE(5, 11));
	FOR i IN 1..num_profs LOOP
		SELECT id
		INTO v_universidad_id
		FROM universidad
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaProfesor(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;

	/*
	*	Se insertan alumnos
	*/
	-- Se insertan entre 30 y 40 alumnos en las universidades que tienen profesores de manera aleatoria
	num_studs := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_studs LOOP
		SELECT DISTINCT universidad_id
		INTO v_universidad_id
		FROM profesor_responsable
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaEstudiante(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre el 80 y 90 % de estudiantes que no hubieran cursado estudios previamente en cursos de manera aleatoria
	*/
	SELECT COUNT(1)
	INTO num_studs
	FROM estudiante e
	WHERE NOT EXISTS (
		SELECT 1
		FROM cursa c
		WHERE c.estudiante_id = e.id
	);
	
	num_cursa := FLOOR(DBMS_RANDOM.VALUE(num_studs * 0.8, num_studs * 0.9));
	FOR i IN 1..num_cursa LOOP
		SELECT e.universidad_id, t.codigo, p.id prof_id, e.id stud_id
		INTO v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id
		FROM estudiante e
		 JOIN profesor_responsable p ON e.universidad_id = p.universidad_id
		 CROSS JOIN titulacion t
		WHERE e.id NOT IN (
			SELECT DISTINCT estudiante_id
			FROM cursa
		)
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaCursa(v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id, anyoActual());
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre 30 y 40 ofertas con entre 2 y 5 plazas cada una
	*/
	num_offers := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_offers LOOP
		SELECT empresa_id, id
		INTO v_empresa_id, v_solicitante_id
		FROM solicitante
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaOferta(v_empresa_id, v_solicitante_id, DBMS_RANDOM.STRING('A', 30), NULL, FLOOR(DBMS_RANDOM.VALUE(2, 6)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	v_datmin_j := TO_NUMBER(TO_CHAR(TO_DATE('01/09/2022', 'dd/mm/rrrr'), 'J'));
	v_datmax_j := TO_NUMBER(TO_CHAR(TO_DATE('01/04/2023', 'dd/mm/rrrr'), 'J'));
	/*
	*	De los estudiantes que cursan estudios en el año académico actual se presentan candidaturas a entre 1 y 3 ofertas
	*/
    FOR cursa IN cursando LOOP
        num_cands := FLOOR(DBMS_RANDOM.VALUE(1, 4));
        FOR oferta IN ofertas(num_cands) LOOP
            v_resultado := pq_abm.altaCandidatura(cursa.universidad_id, cursa.estudiante_id, oferta.id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
        END LOOP;
    END LOOP;
	
	/*
	*	Se realizan entrevistas para todas las candidaturas presentadas
	*/
	FOR candidate IN candidates LOOP
        v_resultado := pq_abm.altaEntrevista(candidate.universidad_id, candidate.estudiante_id, candidate.oferta_id, candidate.empresa_id, candidate.solicitante_id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'),  DBMS_RANDOM.STRING('A', 30), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
    END LOOP;
	
	/*
	*	De las entrevistas con resultado apto se obtienen las colaboraciones
	*/
	FOR entrevista IN entrevistas LOOP
		v_fecha_inicio := TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmin_j + 60)), 'J');
		v_fecha_final := ADD_MONTHS(v_fecha_inicio, FLOOR(DBMS_RANDOM.VALUE(6, 13)));
		v_resultado := pq_abm.altaColaboracion(entrevista.empresa_id, entrevista.universidad_id, entrevista.estudiante_id, entrevista.oferta_id, v_fecha_inicio, v_fecha_final, FLOOR(DBMS_RANDOM.VALUE(3, 11)) * 100, FLOOR(DBMS_RANDOM.VALUE(3, 11)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se realizan inspecciones de manera aleatoria entre las empresas que tienen contratos de prácticas
	*/
	FOR inspeccionable IN inspeccionables LOOP
		num_inspec := FLOOR(DBMS_RANDOM.VALUE(inspeccionable.meses / 2, inspeccionable.meses));
		v_datmin_j := TO_NUMBER(TO_CHAR(inspeccionable.inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(inspeccionable.final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / num_inspec);
		v_fech_insp_j := v_datmin_j + v_salto;
		
		FOR i IN 1..num_inspec LOOP
			v_resultado := pq_abm.altaInspeccion(inspeccionable.empresa_id, TO_DATE(v_fech_insp_j, 'J'), DBMS_RANDOM.STRING('A', 30));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fech_insp_j := v_fech_insp_j + v_salto;
		END LOOP;
	END LOOP;
	
	/*
	*	Se insertan los informes de cada colaboración
	*/
	FOR colaboracion IN colaboraciones LOOP
		v_datmin_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / colaboracion.informes_esperados);
		v_fecha_inf_j := v_datmin_j + v_salto;
		
		FOR i IN 1..colaboracion.informes_esperados - 1 LOOP
			v_resultado := pq_abm.altaInforme(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fecha_inf_j := v_fecha_inf_j + v_salto;
		END LOOP;
		
		v_fecha_inf_j := v_datmax_j + 5;
		v_resultado := pq_abm.altaInformeFinal(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200), DBMS_RANDOM.STRING('A', 200), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	-- Se modifica el curso actual al siguiente curso actualizando las tablas del repositorio estadístico
	pq_dw.resetCurso('22-23');
	
	-- Se dan de alta dos nuevas universidades
	v_resultado := pq_abm.altaUniversidad('Universidad Internacional de Catalunya (UIC)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;
	v_resultado := pq_abm.altaUniversidad('Universidad Abat Oliba (UAO-CEU)', DBMS_RANDOM.STRING('A', 15), DBMS_RANDOM.STRING('A', 15));
	IF v_resultado <> 'OK' THEN
		DBMS_OUTPUT.PUT_LINE(v_resultado);
	END IF;

	
	-- Se insertan entre 5 y 10 profesores nuevos manera aleatoria
	num_profs := FLOOR(DBMS_RANDOM.VALUE(5, 11));
	FOR i IN 1..num_profs LOOP
		SELECT id
		INTO v_universidad_id
		FROM universidad
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaProfesor(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;

	/*
	*	Se insertan alumnos
	*/
	-- Se insertan entre 30 y 40 alumnos en las universidades que tienen profesores de manera aleatoria
	num_studs := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_studs LOOP
		SELECT DISTINCT universidad_id
		INTO v_universidad_id
		FROM profesor_responsable
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaEstudiante(v_universidad_id, a_nombre(FLOOR(DBMS_RANDOM.VALUE(1, a_nombre.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))), a_apellido(FLOOR(DBMS_RANDOM.VALUE(1, a_apellido.count + 1))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre el 80 y 90 % de estudiantes que no hubieran cursado estudios previamente en cursos de manera aleatoria
	*/
	SELECT COUNT(1)
	INTO num_studs
	FROM estudiante e
	WHERE NOT EXISTS (
		SELECT 1
		FROM cursa c
		WHERE c.estudiante_id = e.id
	);
	
	num_cursa := FLOOR(DBMS_RANDOM.VALUE(num_studs * 0.8, num_studs * 0.9));
	FOR i IN 1..num_cursa LOOP
		SELECT e.universidad_id, t.codigo, p.id prof_id, e.id stud_id
		INTO v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id
		FROM estudiante e
		 JOIN profesor_responsable p ON e.universidad_id = p.universidad_id
		 CROSS JOIN titulacion t
		WHERE e.id NOT IN (
			SELECT DISTINCT estudiante_id
			FROM cursa
		)
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaCursa(v_universidad_id, v_titulacion_cod, v_profesor_id, v_estudiante_id, anyoActual());
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se dan de alta entre 30 y 40 ofertas con entre 2 y 5 plazas cada una
	*/
	num_offers := FLOOR(DBMS_RANDOM.VALUE(30, 41));
	FOR i IN 1..num_offers LOOP
		SELECT empresa_id, id
		INTO v_empresa_id, v_solicitante_id
		FROM solicitante
		ORDER BY DBMS_RANDOM.VALUE
		FETCH FIRST 1 ROWS ONLY;
		
		v_resultado := pq_abm.altaOferta(v_empresa_id, v_solicitante_id, DBMS_RANDOM.STRING('A', 30), NULL, FLOOR(DBMS_RANDOM.VALUE(2, 6)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	v_datmin_j := TO_NUMBER(TO_CHAR(TO_DATE('01/09/2022', 'dd/mm/rrrr'), 'J'));
	v_datmax_j := TO_NUMBER(TO_CHAR(TO_DATE('01/04/2023', 'dd/mm/rrrr'), 'J'));
	/*
	*	De los estudiantes que cursan estudios en el año académico actual se presentan candidaturas a entre 1 y 3 ofertas
	*/
    FOR cursa IN cursando LOOP
        num_cands := FLOOR(DBMS_RANDOM.VALUE(1, 4));
        FOR oferta IN ofertas(num_cands) LOOP
            v_resultado := pq_abm.altaCandidatura(cursa.universidad_id, cursa.estudiante_id, oferta.id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
        END LOOP;
    END LOOP;
	
	/*
	*	Se realizan entrevistas para todas las candidaturas presentadas
	*/
	FOR candidate IN candidates LOOP
        v_resultado := pq_abm.altaEntrevista(candidate.universidad_id, candidate.estudiante_id, candidate.oferta_id, candidate.empresa_id, candidate.solicitante_id, TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmax_j)), 'J'),  DBMS_RANDOM.STRING('A', 30), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
    END LOOP;
	
	/*
	*	De las entrevistas con resultado apto se obtienen las colaboraciones
	*/
	FOR entrevista IN entrevistas LOOP
		v_fecha_inicio := TO_DATE(FLOOR(DBMS_RANDOM.VALUE(v_datmin_j, v_datmin_j + 60)), 'J');
		v_fecha_final := ADD_MONTHS(v_fecha_inicio, FLOOR(DBMS_RANDOM.VALUE(6, 13)));
		v_resultado := pq_abm.altaColaboracion(entrevista.empresa_id, entrevista.universidad_id, entrevista.estudiante_id, entrevista.oferta_id, v_fecha_inicio, v_fecha_final, FLOOR(DBMS_RANDOM.VALUE(3, 11)) * 100, FLOOR(DBMS_RANDOM.VALUE(3, 11)));
		IF v_resultado <> 'OK' THEN
			DBMS_OUTPUT.PUT_LINE(v_resultado);
		END IF;
	END LOOP;
	
	/*
	*	Se realizan inspecciones de manera aleatoria entre las empresas que tienen contratos de prácticas
	*/
	FOR inspeccionable IN inspeccionables LOOP
		num_inspec := FLOOR(DBMS_RANDOM.VALUE(inspeccionable.meses / 2, inspeccionable.meses));
		v_datmin_j := TO_NUMBER(TO_CHAR(inspeccionable.inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(inspeccionable.final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / num_inspec);
		v_fech_insp_j := v_datmin_j + v_salto;
		
		FOR i IN 1..num_inspec LOOP
			v_resultado := pq_abm.altaInspeccion(inspeccionable.empresa_id, TO_DATE(v_fech_insp_j, 'J'), DBMS_RANDOM.STRING('A', 30));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fech_insp_j := v_fech_insp_j + v_salto;
		END LOOP;
	END LOOP;
	
	/*
	*	Se insertan los informes de cada colaboración
	*	En esta última iteración se introducen dos factores aleatorios para dejar colaboraciones sin finalizar
	*/
	FOR colaboracion IN colaboraciones LOOP
		v_datmin_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_inicio, 'J'));
		v_datmax_j := TO_NUMBER(TO_CHAR(colaboracion.fecha_final, 'J'));
		v_salto := FLOOR((v_datmax_j - v_datmin_j) / colaboracion.informes_esperados);
		v_fecha_inf_j := v_datmin_j + v_salto;
		v_salida := CEIL(colaboracion.informes_esperados / 2);
		
		FOR i IN 1..colaboracion.informes_esperados - 1 LOOP
			v_resultado := pq_abm.altaInforme(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
			v_fecha_inf_j := v_fecha_inf_j + v_salto;
			
			IF v_salida = FLOOR(DBMS_RANDOM.VALUE(1, colaboracion.informes_esperados)) THEN
				v_salida := 0;
				EXIT;
			END IF;
		END LOOP;
		
		IF v_salida > 0  AND FLOOR(DBMS_RANDOM.VALUE(1, 6)) > 1 THEN
			v_fecha_inf_j := v_datmax_j + 5;
			v_resultado := pq_abm.altaInformeFinal(colaboracion.empresa_id, colaboracion.universidad_id, colaboracion.estudiante_id, colaboracion.oferta_id, colaboracion.solicitante_id, TO_DATE(v_fecha_inf_j, 'J'), DBMS_RANDOM.STRING('A', 200), DBMS_RANDOM.STRING('A', 200), TO_CHAR(FLOOR(DBMS_RANDOM.VALUE(0, 2))));
			IF v_resultado <> 'OK' THEN
				DBMS_OUTPUT.PUT_LINE(v_resultado);
			END IF;
		END IF;
	END LOOP;
END;
